/*
 * Copyright (c) 2011 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.terasoluna.fw.batch.dao.support;

import java.util.Comparator;
import java.util.List;

import jp.terasoluna.fw.dao.SqlHolder;
import jp.terasoluna.fw.dao.UpdateDAO;

/**
 * ob`XVT|[gC^tF[X<br>
 * <p>
 * {NX̃\bhsOsort\bhsĂꍇA<br>
 * ̓RXgN^s\bhȂǂComparatornꍇ́A<br>
 * \[gɕёւB<br>
 * </p>
 * @see UpdateDAO
 */
public interface BatchUpdateSupport {
    /** UpdateDAOnull̂Ƃ̃G[Xe[^X */
    int ERROR_UPDATE_DAO_IS_NULL = -100;

    /** sqlIdOrderɎw肳ĂȂSQL-IDw肳ĂƂ̃G[Xe[^X */
    int ERROR_UNKNOWN_SQL_ID = -200;

    /**
     * ob`spSQLǉB<br>
     * @param sqlID String
     * @param bindParams Object
     */
    void addBatch(final String sqlID, final Object bindParams);

    /**
     * ob`ssB<br>
     * <p>
     * ob`sꍇ́AێĂob`sSQLXg̍폜sB
     * </p>
     * <p>
     * {\bhŎsꍇ́ARXgN^UpdateDAOnĂƁB<br>
     * UpdateDAORXgN^œnĂȂꍇ́A-100ԋpB
     * </p>
     * @return SQL̎s
     * @see UpdateDAO
     */
    int executeBatch();

    /**
     * ob`ssB<br>
     * <p>
     * ob`sꍇ́AێĂob`sSQLXg̍폜sB
     * </p>
     * <p>
     * {\bhŎsꍇ́ARXgN^œnꂽUpdateDAO͎gpȂB<br>
     * UpdateDAOnull̏ꍇ́A-100ԋpB
     * </p>
     * @param updateDAO UpdateDAO
     * @return SQL̎s
     * @see UpdateDAO
     */
    int executeBatch(UpdateDAO updateDAO);

    /**
     * ob`ssB<br>
     * <p>
     * ob`sꍇ́AێĂob`sSQLXg̍폜sB
     * </p>
     * <p>
     * {\bhŎsꍇ́ARXgN^œnꂽUpdateDAO͎gpȂB<br>
     * UpdateDAOnull̏ꍇ́A-100ԋpB
     * </p>
     * <p>
     * ComparatornƂɂSQLs𐧌łB<br>
     * Comparatornꍇ͕K\[gsBComparatoȓ召fɊÂAŃ\[gsB
     * </p>
     * @param updateDAO UpdateDAO
     * @param comparator Comparator&lt;String&gt;
     * @return SQL̎s
     * @see UpdateDAO
     */
    int executeBatch(UpdateDAO updateDAO, Comparator<String> comparator);

    /**
     * ob`ssB<br>
     * <p>
     * ob`sꍇ́AێĂob`sSQLXg̍폜sB
     * </p>
     * <p>
     * {\bhŎsꍇ́ARXgN^œnꂽUpdateDAO͎gpȂB<br>
     * UpdateDAOnull̏ꍇ́A-100ԋpB
     * </p>
     * <p>
     * ȍ~ɎsSQL-IDԂɐݒ肷邱ƂɂSQLs𐧌łB<br>
     * sqlIdOrderSQL-IDw肵ꍇ́AK̏ԂSQLsB<br>
     * ܂A̍ۂsqlIdOrderɎw肳ĂȂSQL-ID݂ꍇ͎sꂸ-200ԋpB<br>
     * </p>
     * @param updateDAO UpdateDAO
     * @param sqlIdOrder SQL-ID̎sw肷
     * @return SQL̎s
     * @see UpdateDAO
     */
    int executeBatch(UpdateDAO updateDAO, String... sqlIdOrder);

    /**
     * ob`sSQLXg̃\[gsB<br>
     * <p>
     * executeBatchgetSqlHolderListsOɖ{\bhs邱ƂŁA<br>
     * SQL̎sSQL-ID̏ɕёւ邱ƂłB
     * </p>
     * <p>
     * {\bhs^C~OŎۂɓŃ\[gs邩ǂ͋K肵Ȃ
     * </p>
     */
    void sort();

    /**
     * ob`sSQLXg̃\[gsB<br>
     * <p>
     * executeBatchgetSqlHolderListsOɖ{\bhs邱ƂŁA<br>
     * SQL̎sComparatorɏ]ĕёւ邱ƂłB
     * </p>
     * <p>
     * ComparatornƂɂSQL̕ёւ𐧌łB<br>
     * iComparatornꍇ͕K\[gsBComparatoȓ召fɊÂAŃ\[gsBj
     * </p>
     * <p>
     * {\bhs^C~OŎۂɓŃ\[gs邩ǂ͋K肵Ȃ
     * </p>
     * @param comparator Comparator&lt;String&gt;
     */
    void sort(Comparator<String> comparator);

    /**
     * ob`sSQLXg̓e폜B<br>
     * <p>
     * ێĂob`sSQLXg̍폜sB
     * </p>
     */
    void clear();

    /**
     * ob`sSQLXg̓o^擾B<br>
     * @return ob`sSQLXg̓o^
     */
    long size();

    /**
     * SQL-IDŐ񂳂ꂽSqlHolderXg擾B<br>
     * <p>
     * ێĂob`sSQLXgSQL-IDɐ񂵂XgԋpB
     * </p>
     * <p>
     * {\bhsĂێĂob`sSQLXg͍폜ȂB
     * </p>
     * @return SqlHolderXg
     */
    List<SqlHolder> getSqlHolderList();

    /**
     * SQL-IDŐ񂳂ꂽSqlHolderXg擾B<br>
     * <p>
     * ێĂob`sSQLXgSQL-IDɐ񂵂XgԋpB
     * </p>
     * <p>
     * {\bhsĂێĂob`sSQLXg͍폜ȂB
     * </p>
     * <p>
     * ComparatornƂɂSQL̕ёւ𐧌łB<br>
     * Comparatornꍇ͕K\[gsBComparatoȓ召fɊÂAŃ\[gsB
     * </p>
     * @param comparator Comparator&lt;String&gt;
     * @return SqlHolderXg
     */
    List<SqlHolder> getSqlHolderList(Comparator<String> comparator);

    /**
     * SQL-IDŐ񂳂ꂽSqlHolderXg擾B<br>
     * <p>
     * ێĂob`sSQLXgSQL-IDɐ񂵂XgԋpB
     * </p>
     * <p>
     * {\bhsĂێĂob`sSQLXg͍폜ȂB
     * </p>
     * <p>
     * sSQL-IDԂɐݒ肷邱Ƃɂ擾SqlHolderXg̏𐧌łB<br>
     * sqlIdOrderSQL-IDw肵ꍇ́AK̏ԂSQLёւB<br>
     * ܂A̍ۂsqlIdOrderɎw肳ĂȂSQL-ID݂ꍇnullԋpB<br>
     * </p>
     * @param sqlIdOrder SQL-ID̎sw肷
     * @return SqlHolderXg
     */
    List<SqlHolder> getSqlHolderList(String... sqlIdOrder);

}
